﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;
using Infragistics.Controls.Editors;
using System.Collections;

namespace XamRibbonCombo
{
    public class XamComboEditorTool : RibbonTool
    {
        protected override RibbonToolBaseControl ResolveToolControl()
        {
            return new XamComboEditorToolControl(this);
        }

        public IEnumerable ItemsSource 
        {
            get { return (IEnumerable)GetValue(ItemsSourceProperty); }
            set { SetValue(ItemsSourceProperty, value); }
        }

        public static readonly DependencyProperty ItemsSourceProperty =
            DependencyProperty.Register("ItemsSource", typeof(IEnumerable),
            typeof(XamComboEditorTool), null);

        public String DisplayMemberPath { get; set; }
    }

    public class XamComboEditorToolControl : RibbonToolBaseControl, IRibbonControl
    {
        private XamComboEditor _combo;

        public XamComboEditorToolControl()
        {
            this.DefaultStyleKey = typeof(XamComboEditorToolControl);
        }

        public XamComboEditorToolControl(RibbonToolBase tool)
            : base(tool)
        {
            this.DefaultStyleKey = typeof(XamComboEditorToolControl);
        }

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            this._combo = GetTemplateChild("XamComboEditor") as XamComboEditor;
            if (this._combo != null)
            {
                this._combo.ItemsSource = ((XamComboEditorTool)this.Tool).ItemsSource;
                this._combo.DisplayMemberPath = ((XamComboEditorTool)this.Tool).DisplayMemberPath;
            }
        }
    }
}
